#include "Sonar.h"
#include <StringView.h>
#include <stdlib.h>

// MAIN INSTANTIATION FUNCTION
extern "C" _EXPORT BScreenSaver *instantiate_screen_saver(BMessage *message, image_id image)
{
	return new Sonar(message, image);
}

Sonar::Sonar(BMessage *message, image_id image)
 : BScreenSaver(message, image)
{
}

void Sonar::StartConfig(BView *view)
{
	tview = new BStringView(BRect(10, 10, 200, 35), B_EMPTY_STRING, "Sonar Saver");
	tview->SetFont(be_bold_font);
	tview->SetFontSize(15);
	view->AddChild(tview);
	view->AddChild(new BStringView(BRect(20, 35, 200, 50), B_EMPTY_STRING, "   Ver. 1.0.0 / Oct, 11 ,2001 (C)Tarcus"));
	view->AddChild(new BStringView(BRect(20, 50, 200, 75), B_EMPTY_STRING, "WinBe (English)"));
	view->AddChild(new BStringView(BRect(30, 80, 200, 100), B_EMPTY_STRING, "http://menber.nifty.ne.jp/tarucus/"));
	view->AddChild(new BStringView(BRect(30, 100, 200, 120), B_EMPTY_STRING, "       english/be/beos.htm"));
	view->AddChild(new BStringView(BRect(20, 130, 200, 155), B_EMPTY_STRING, "WinBe (Japanese)"));
	view->AddChild(new BStringView(BRect(30, 150, 200, 170), B_EMPTY_STRING, "http://menber.nifty.ne.jp/tarucus/"));
	view->AddChild(new BStringView(BRect(30, 170, 200, 190), B_EMPTY_STRING, "       be/beos.htm"));}

status_t Sonar::StartSaver(BView *, bool /* preview */)
{
	SetTickSize(50000);
	rad = 0.05;
	return B_OK;
}

void Sonar::Draw(BView *view, int32)
{
BPoint p1, p2;
int x,y;
bool first = true;

if (first = true) {
	x = view->Bounds().IntegerWidth() / 2;
	y = view->Bounds().IntegerHeight() / 2;
	p1.Set(x, y);
	first = false;
}

p2.Set(x * cos(rad) - y * sin(rad) + x, x * sin(rad) + y * cos(rad) + y);

if (rad == 0.0)
	{
		view->SetHighColor(rand() % 255,rand() % 255,rand() % 255);
	}

rad = rad + 0.01;

if (rad > 6.283) {
		rad = 0.0;
	}

view->StrokeLine(p2, p1);

}
